#include <vector>

#include "CBinaire.h"

namespace persistance {

// ________________________________________________________________________________________
std::string CBinaire::lireClasse (std::istream& prFlux) {

	return lireChaine (prFlux);
	};

// ________________________________________________________________________________________
std::string CBinaire::lireMetadonnee (std::istream& prFlux) {

	return lireChaine (prFlux);
	};

// ________________________________________________________________________________________
std::string CBinaire::lireChaine (std::istream& prFlux) {

	size_t lvLongueur;
	char* laBuffer = (char*)&lvLongueur;

	// Lecture de mvChaine dans le flux
	prFlux.read (laBuffer, sizeof (lvLongueur));
	std::vector<char> lvChaine (1+lvLongueur);
	prFlux.read (lvChaine.data (), lvLongueur);
	lvChaine [lvLongueur] = 0;
	return lvChaine.data ();
	};

// ________________________________________________________________________________________
bool CBinaire::dernierLu (std::istream& prFlux) {

	std::streampos lvPosition = prFlux.tellg ();
	prFlux.seekg (0, prFlux.end);
	std::streampos lvTaille = prFlux.tellg ();
	prFlux.seekg (lvPosition);

	return (lvPosition >= lvTaille);
	};

// ________________________________________________________________________________________
void CBinaire::lireInfo (std::istream& prFlux, char* const laBuffer, const std::streamsize kpvTaille) {

	// Lecture de l'information binaire
	prFlux.read (laBuffer, kpvTaille);
	};

// ________________________________________________________________________________________
void CBinaire::ecrireClasse (std::ostream& prFlux, const std::string& kprClasse) {

	ecrireChaine (prFlux, kprClasse);
	};

// ________________________________________________________________________________________
void CBinaire::ecrireMetadonnee (std::ostream& prFlux, const std::string& kprMetaDonnee) {

	ecrireChaine (prFlux, kprMetaDonnee);
	};

// ________________________________________________________________________________________
void CBinaire::ecrireInfo (std::ostream& prFlux, const std::string& kprTypeCPP, const char* const kpaBuffer, const std::streamsize kpvTaille) {

	prFlux.write (kpaBuffer, kpvTaille);
	};

// ________________________________________________________________________________________
void CBinaire::ecrireChaine (std::ostream& prFlux, const std::string& kprChaine) {

	size_t lvLongueur = kprChaine.length ();
	char* laBuffer = (char*)&lvLongueur;

	prFlux.write (laBuffer, sizeof (lvLongueur));
	prFlux.write (kprChaine.c_str (), lvLongueur);
	};

};

