#ifndef CPARCELLEPERSISTANTE_CC
#define CPARCELLEPERSISTANTE_CC

#include <sstream>

#include "CParcellePersistante.model.h"

namespace persistance {

// ________________________________________________________________________________________
template <class TStrategie>
std::string CParcellePersistante<TStrategie>::smvNomClasse = "";

// ________________________________________________________________________________________
template <class TStrategie>
CParcellePersistante<TStrategie>::CParcellePersistante (const std::string& kprIDU, const double kpvSurface, bool pvPersistant, bool pvAlloue) :
	CPersistant<TStrategie> (pvPersistant, pvAlloue),
	mvIDU (kprIDU),
	mvSurface (kpvSurface) {};

// ________________________________________________________________________________________
template <class TStrategie>
CParcellePersistante<TStrategie>::CParcellePersistante (std::istream& prFlux) :
	CPersistant<TStrategie> (prFlux) {

	std::streamsize lvTaille = sizeof (mvSurface);
	char* laBuffer = (char*)&mvSurface;

	for (uint16_t lvI=0; lvI<2; lvI++) {
		std::string lvMetadonnee = TStrategie::lireMetadonnee (prFlux);

		if (lvMetadonnee == "IDU") {
			mvIDU = TStrategie::lireChaine (prFlux);
			};
		if (lvMetadonnee == "Surface") {
			TStrategie::lireInfo (prFlux, laBuffer, lvTaille);
			};
		};
	};

// ________________________________________________________________________________________
template <class TStrategie>
void  CParcellePersistante<TStrategie>::ecrire (std::ostream& prFlux) const {

	std::streamsize lvTaille = sizeof (mvSurface);
	char* laBuffer = (char*)&mvSurface;

	CPersistant<TStrategie>::ecrire (prFlux);

	TStrategie::ecrireMetadonnee (prFlux, "IDU");
	TStrategie::ecrireChaine (prFlux, mvIDU);

	TStrategie::ecrireMetadonnee (prFlux, "Surface");
	TStrategie::ecrireInfo (prFlux, "double", laBuffer, lvTaille);
	};

// ________________________________________________________________________________________
template <class TStrategie>
void  CParcellePersistante<TStrategie>::referencer () {

	if (smvNomClasse.length () == 0)
		smvNomClasse = "persistance::CParcellePersistante<" + TStrategie::nomStrategie () + ">";
	CBasePersistant::constructeur fnConstructeur = &CParcellePersistante<TStrategie>::constructeur;

	::persistance::CPersistant<TStrategie>::referencer (smvNomClasse, fnConstructeur);
	};

};

#endif // CPARCELLEPERSISTANTE_CC
