#ifndef CPERSISTANT_CC
#define CPERSISTANT_CC

#include <sstream>

#include "CPersistant.model.h"

namespace persistance {

// ________________________________________________________________________________________
template <class TStrategie>
CPersistant<TStrategie>::CPersistant (bool pvPersistant, bool pvAlloue) : CBasePersistant (pvPersistant, pvAlloue) {};

// ________________________________________________________________________________________
template <class TStrategie>
CPersistant<TStrategie>::CPersistant (std::istream& prFlux) :
	CBasePersistant (prFlux) {

	};

// ________________________________________________________________________________________
template <class TStrategie>
uint64_t CPersistant<TStrategie>::taille () const {

	std::ostringstream lvOSS (TStrategie::mode ());
	ecrire (lvOSS);
	return lvOSS.tellp ();
	};

// ________________________________________________________________________________________
template <class TStrategie>
void CPersistant<TStrategie>::ecrire (std::ostream& prFlux) const {

	TStrategie::ecrireClasse (prFlux, nomClasse ());
	};

// ________________________________________________________________________________________
template <class TStrategie>
void CPersistant<TStrategie>::toutEcrire (std::ostream& prFlux) {

	prFlux.seekp (0);
	TStrategie::ecrireEntete (prFlux);
	CBasePersistant::toutEcrire (prFlux);
	TStrategie::ecrirePied (prFlux);
	};

// ________________________________________________________________________________________
template <class TStrategie>
void CPersistant<TStrategie>::lire (std::istream& prFlux) {

	std::string lvClasse;
	bool lvReference = true;

	prFlux.seekg (0);
	TStrategie::lireEntete (prFlux);

	while (!TStrategie::dernierLu (prFlux) && lvReference) {
		lvClasse = TStrategie::lireClasse (prFlux);

		// Recherche du constructeur virtuel dans le référentiel
		std::map<std::string, constructeur>::const_iterator kliRefConstructeur = smaReferentiel->find (lvClasse);
		if (kliRefConstructeur != smaReferentiel->end ()) {
			// Construction par flux
			CPersistant::constructeur fnConstructeur = kliRefConstructeur->second;
			(*fnConstructeur) (prFlux);
			lvReference = true;
			}
		else {
			lvReference = false;
			std::cerr << "Constructeur virtuel " << lvClasse << " non référencé" << std::endl;
			};
		};
	};

};

#endif // CPERSISTANT_CC
